Minimum Cost to Hire K Workers - Leetcode 857 - Python

  Рет қаралды 14,942

NeetCodeIO

NeetCodeIO

Күн бұрын

Пікірлер: 79
@NeetCodeIO
@NeetCodeIO 6 ай бұрын
Sorry I missed so many days lately. I'll be much more consistent going forward. You can count on it!
@metarus208
@metarus208 6 ай бұрын
pls make more coding content going forward
@yang5843
@yang5843 6 ай бұрын
Would a financial incentive motivate you to make videos the day of?
@diaaabusaada910
@diaaabusaada910 6 ай бұрын
We've missed you my friend😉
@gryffindor6409
@gryffindor6409 6 ай бұрын
ok
@ik6071
@ik6071 6 ай бұрын
is it still possible to upload videos on the days you missed?
@asmodeus159
@asmodeus159 6 ай бұрын
Companies asking this question in Interview ❌ Companies implementing this ✅
@tusharsingh3480
@tusharsingh3480 6 ай бұрын
3:20 "if we wanna be full capitalists" - Neetcode
@shivamgupta3293
@shivamgupta3293 2 ай бұрын
this was personal
@venkateshnaidu2133
@venkateshnaidu2133 6 ай бұрын
There's no way I can come up with this logic in an interview
@prakhargupta4320
@prakhargupta4320 6 ай бұрын
may be with some help from the interviewer
@visintel
@visintel 6 ай бұрын
Practice heap medium level questions. It helps me to look at solutions when I’m stuck. You’re right, it’s hard to come up with this but it gets easier when you practice and study solutions. You’ll be stuck less and less with practice
@rawatvinod4164
@rawatvinod4164 6 ай бұрын
this one got me confused for days but your explanations always helps me understand every problem better.
@antm9957
@antm9957 6 ай бұрын
Thanks! Don't disappear for so long.
@iliadmitriev01
@iliadmitriev01 6 ай бұрын
*capitalists have left the conversation you can get 20 units of work for the half price (50) no, I can get 15 units for the double price (105)
@JamesBond-mq7pd
@JamesBond-mq7pd 6 ай бұрын
Yup. Absurd
@kareemadesola6522
@kareemadesola6522 6 ай бұрын
Thank you for significantly reducing the time I would have spent on the editorial
@JamesBond-mq7pd
@JamesBond-mq7pd 6 ай бұрын
I have tried to solve this task for 2 hours! Unreal problem!
@EduardYudinkov
@EduardYudinkov 6 ай бұрын
Thank you for the best explanation ever! After the first 4-5 minutes of the video, I was able to figure out a solution on my own.
@LimpBizkit195
@LimpBizkit195 6 ай бұрын
I think the time complexity can be simplified as O(nlogn) since n >= k
@krit2038
@krit2038 6 ай бұрын
What about the case when the max value that you pop from the heap is the value that you have just added, in that case would it still be valid to evaluate res using the current rate?
@aadharjain313
@aadharjain313 6 ай бұрын
same doubt??
@siddharth-gandhi
@siddharth-gandhi 6 ай бұрын
my guess is you can prove that total_quality * rate would be less than the res at that time, so doesn't matter. tho i havent proved lol
@pogman1
@pogman1 6 ай бұрын
It's because since we know that the rates are increasing as we loop through, you can guarantee that total_quality * rate will be larger. I.e. the total quality was 10, we add a new guy with a higher rate, if we pop this guy because he has a higher quantity too, we'll basically be doing 10* higher rate which will be >= 10*prev rate
@aadharjain313
@aadharjain313 6 ай бұрын
@@pogman1 but that won't be the minimum cost then ?
@pogman1
@pogman1 6 ай бұрын
@@aadharjain313 it would be since you take the minimum. In the example I gave it would be min(10* prev rate, 10*higher rate) which is guaranteed to be 10*prev rate bc of what I mentioned
@lakshmanprabhu6722
@lakshmanprabhu6722 6 ай бұрын
Best explanation!! Thank you
@taqihaider9879
@taqihaider9879 6 ай бұрын
Best explanation !
@JRK_RIDES
@JRK_RIDES 6 ай бұрын
Thanks man, your videos help a lot.
@sirajussalekin9239
@sirajussalekin9239 6 ай бұрын
this has to be the most convoluted explanation of K workers problem I've heard 😅
@rostislav_engineer
@rostislav_engineer 6 ай бұрын
thank you neetcode
@Munchen888
@Munchen888 6 ай бұрын
Please help me with this question. I'm going to use sliding window starting from 1 to len(quality) . From heap I'm going to pop when : while heap and len(heap) > k, heapq.heappop(heap). But I don't realize how to check when I am heappush to heap?
@krateskim4169
@krateskim4169 6 ай бұрын
Awesome explanation
@aritrobiswas6439
@aritrobiswas6439 6 ай бұрын
What I learned today is being too good at your job is not necessarily going to get you a job.
@Sarwaan001
@Sarwaan001 6 ай бұрын
This is very similar to a question that we ask at Disney+
@ChickenWangTFT
@ChickenWangTFT 6 ай бұрын
thank you king
@kwakukusi4094
@kwakukusi4094 6 ай бұрын
thanks, I did not even understand the question
@nikhilanand984
@nikhilanand984 6 ай бұрын
while we are subtracting the maximum quality (since it's a maxheap) when the size of the heap becomes > k (k + 1), suppose our current quality is the maximum quality and we subtracted it from our total quality, but we are still using it's rate (which will be the maximum rate till now since rates are stored in ascending order) to get the minimum total wage by multiplying it with the total quality till now after the subtraction of the current maximum quality. basically we are multiplying the rate of that current quality with the total previous quality we already calculated an answer for. though this won't change our minimum answer till now since we are multiplying it with a greater rate, but still this is wrong. maybe we can also maintain a maximum quality and whenever we are popping the maximum quality, we won't use its rate to find the answer.
@MykolaPavluchynskyi
@MykolaPavluchynskyi 6 ай бұрын
Yes, this bothers me as well. Maybe we should put to the heap not just quality - but pair we are processing. If if the pair we have to remove - is the same we just added - just skip it...
@MykolaPavluchynskyi
@MykolaPavluchynskyi 6 ай бұрын
Probably wiser would be to delete the max element right after processing with size k, that way don't have such situation at all
@MykolaPavluchynskyi
@MykolaPavluchynskyi 6 ай бұрын
Queue qualityQueue = new PriorityQueue((a,b) -> Integer.compare(b.quality, a.quality)); for (Worker worker : workers) { qualityQueue.add(worker); qualitySum += worker.quality; if (qualityQueue.size() == k) { final double biggestRateByNow = worker.ratePerQuality; final double resultCandidate = qualitySum * biggestRateByNow; result = Math.min(result, resultCandidate); Worker biggestQualityWorker = qualityQueue.poll(); qualitySum -= biggestQualityWorker.quality; } }
@Techgether
@Techgether 6 ай бұрын
Hi navdeep, any good resource recommendations to learn how to determine space and time complexity for my own created solution? and also any website that can explains DSA terminology well?
@mariansalam
@mariansalam 6 ай бұрын
College
@Techgether
@Techgether 6 ай бұрын
@@mariansalam damn
@CS_n00b
@CS_n00b 5 ай бұрын
very cool
@torvasdh
@torvasdh 6 ай бұрын
This is somehow worse than current industry pay scaling, so expect to see this adopted next year.
@juanmacias5922
@juanmacias5922 6 ай бұрын
I think what makes this problem hard is the lack of explanation of what is happening in the question, and solutions haha
@ShikaIE
@ShikaIE 6 ай бұрын
Yes the question is ridiculously confusing
@juanmacias5922
@juanmacias5922 6 ай бұрын
@@ShikaIE right! Even if they just alluded to "grading on a curve" lol
@barnetthan9391
@barnetthan9391 6 ай бұрын
thanks goat
@copilotcoder
@copilotcoder 6 ай бұрын
There is a problem, we are calculating total_quality * rate, but one of the individual wage might hit the wage cap and must be discarded?Can you explain sir
@il5083
@il5083 6 ай бұрын
It's sorted, so the previous rates (wage/quality) are lower, therefore their quality * new_rate would be >= minimum wage.
@_sonu_
@_sonu_ 6 ай бұрын
Hi Bro Are you haring ?
@vishaalkumaranandan2894
@vishaalkumaranandan2894 6 ай бұрын
I am still in some kind of confusion with the code
@pastori2672
@pastori2672 6 ай бұрын
i got TLE am i a failiure ?
@ravatez
@ravatez 6 ай бұрын
You are late man! I solved it but in different way. Keep posting. Don't break streak 😂
@orcus_irl
@orcus_irl 6 ай бұрын
how is he using his pen(whatever) to write on browser bro can someone tell me? is there any software that is smooth as he is using right now? I am open for suggestion regarding software
@MrLeyt1125
@MrLeyt1125 6 ай бұрын
No, he drawing with a real pen on real monitor and takes video with his phone. New video = new monitor, please donate for a new vids
@manuelscott9078
@manuelscott9078 6 ай бұрын
paint 3d
@chien-yucode992
@chien-yucode992 6 ай бұрын
🥳🥳🥳
@rajsuriyang3427
@rajsuriyang3427 6 ай бұрын
I didn't even understand this question
@yogendrakesharwani3650
@yogendrakesharwani3650 4 ай бұрын
When he does (10+5)*7=105 i was like 💀🤡☠️
@supremoluminary
@supremoluminary 6 ай бұрын
Who just deleted my comment?
@Benstokes555
@Benstokes555 6 ай бұрын
AHH DIDNT GET IT
@supremoluminary
@supremoluminary 6 ай бұрын
Put my deleted comment back up.
@NeetCodeIO
@NeetCodeIO 6 ай бұрын
pretty sure yt auto deletes some, usually because of urls
@supremoluminary
@supremoluminary 6 ай бұрын
@@NeetCodeIO I put it up four times. The fourth time, it seems to have stuck. We are no longer safe, there is a link to GitHub.
@toseefalikhan2297
@toseefalikhan2297 6 ай бұрын
Best explanation!
Find the Maximum Sum of Node Values - Leetcode 3068 - Python
17:50
Minimum Cost to Cut a Stick - Leetcode 1547 - Python
12:15
NeetCodeIO
Рет қаралды 14 М.
Noodles Eating Challenge, So Magical! So Much Fun#Funnyfamily #Partygames #Funny
00:33
FOREVER BUNNY
00:14
Natan por Aí
Рет қаралды 25 МЛН
Freedom Trail - Leetcode 514 - Python
25:18
NeetCodeIO
Рет қаралды 14 М.
Become a Malloc() Pro
6:58
thedoubleeguy
Рет қаралды 2,5 М.
Maximum Matrix Sum - Leetcode 1975 - Python
16:07
NeetCodeIO
Рет қаралды 222
Minimum Increment to Make Array Unique - Leetcode 945 - Python
16:20
I Solved 100 LeetCode Problems
13:11
Green Code
Рет қаралды 245 М.
Rotating the Box - Leetcode 1861 - Python
15:14
NeetCodeIO
Рет қаралды 6 М.
Minimum Height Trees - Leetcode 310 - Python
23:30
NeetCodeIO
Рет қаралды 21 М.